'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Author   : roy
 * Date     : 2017-08-08  11:48
 * Describe :
 */

var defaultHandleTrack = function defaultHandleTrack(trackData, controlArg) {
  console.warn('统计实现要自己写啦，handleTrack: (trackData, controlArg) => {}');
};

var Tracker = function Tracker(config) {
  var _this = this;

  _classCallCheck(this, Tracker);

  this.config = {
    commonParams: {},
    handleTrack: defaultHandleTrack,
    showLog: true,
    baseParams: {},
    commonControlArg: {}
  };

  this.track = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(trackData, controlArg) {
      var handleTrackSeccess;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              trackData = _extends({}, promoteValue(_this.config.baseParams), promoteValue(_this.config.commonParams), trackData);
              controlArg = _extends({
                showLog: _this.config.showLog
              }, promoteValue(_this.config.commonControlArg), promoteValue(controlArg));

              handleTrackSeccess = function handleTrackSeccess() {
                if (controlArg.showLog) {
                  console.log('统计发送成功');
                }
              };
              // 发送统计请求


              _context.next = 5;
              return _this.config.handleTrack(trackData, controlArg).then(handleTrackSeccess).catch(console.warn);

            case 5:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();

  this.wrap = createWrap(this.track);
  this.wraper = createWraper(this.track);
  this.injectValue = injectValue;

  this.config = _extends({}, this.config, config);
};

/**
 *  @deprecated
 * use new Tracker(config)
 */


var create = exports.create = function create() {
  var trackConfig = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var t = new Tracker(trackConfig);
  return t.track;
};

var promoteValue = exports.promoteValue = function promoteValue() {
  var target = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var funcArgs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  if ((typeof target === 'undefined' ? 'undefined' : _typeof(target)) === 'object') {
    return target;
  }
  if (typeof target === 'function') {
    return target.apply(undefined, _toConsumableArray(funcArgs));
  }
};

/**
 * only inject type: [Object, Function]
 * @param {*} target [Object, Function]
 * @param {*} newTarget [Object, Function]
 */
var injectValue = exports.injectValue = function injectValue() {
  var target = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var newTarget = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  return function () {
    return _extends({}, promoteValue(target), promoteValue(newTarget));
  };
};

var createWrap = exports.createWrap = function createWrap(targetFunc) {
  return function (func) {
    for (var _len = arguments.length, wrapArgs = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      wrapArgs[_key - 1] = arguments[_key];
    }

    return function () {
      for (var _len2 = arguments.length, funcArgs = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        funcArgs[_key2] = arguments[_key2];
      }

      var trackArgs = wrapArgs.map(function (arg) {
        return promoteValue(arg, funcArgs);
      });
      targetFunc.apply(undefined, _toConsumableArray(trackArgs)).catch(function (e) {});
      return func.apply(undefined, funcArgs);
    };
  };
};

var createWraper = exports.createWraper = function createWraper(targetFunc) {
  return function () {
    for (var _len3 = arguments.length, wrapArgs = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      wrapArgs[_key3] = arguments[_key3];
    }

    return function (func) {
      return function () {
        for (var _len4 = arguments.length, funcArgs = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
          funcArgs[_key4] = arguments[_key4];
        }

        var trackArgs = wrapArgs.map(function (arg) {
          return promoteValue(arg, funcArgs);
        });
        targetFunc.apply(undefined, _toConsumableArray(trackArgs)).catch(function (e) {});
        return func.apply(undefined, funcArgs);
      };
    };
  };
};

exports.default = {
  create: create,
  createWrap: createWrap,
  createWraper: createWraper,
  promoteValue: promoteValue,
  injectValue: injectValue,
  Tracker: Tracker
};
