/**
 * Author   : roy
 * Date     : 2017-08-08  11:48
 * Describe :
 */

const defaultHandleTrack = (trackData, controlArg) => {
  console.warn('统计实现要自己写啦，handleTrack: (trackData, controlArg) => {}')
}

class Tracker {
  config = {
    commonParams: {},
    handleTrack: defaultHandleTrack,
    showLog: true,
    baseParams: {},
    commonControlArg: {}
  }

  constructor(config) {
    this.config = {
      ...this.config,
      ...config
    }
  }

  track = async(trackData, controlArg) => {
    trackData = {
      ...promoteValue(this.config.baseParams),
      ...promoteValue(this.config.commonParams),
      ...trackData
    }
    controlArg = {
      showLog: this.config.showLog,
      ...promoteValue(this.config.commonControlArg),
      ...promoteValue(controlArg)
    }

    const handleTrackSeccess = () => {
      if (controlArg.showLog) {
        console.log('统计发送成功')
      }
    }
    // 发送统计请求
    await this.config.handleTrack(trackData, controlArg)
      .then(handleTrackSeccess)
      .catch(console.warn)
  }

  wrap = createWrap(this.track)
  wraper = createWraper(this.track)
  injectValue = injectValue
}

/**
 *  @deprecated
 * use new Tracker(config)
 */
export const create = (trackConfig = {}) => {
  let t = new Tracker(trackConfig)
  return t.track
}

export const promoteValue = (target = {}, funcArgs = []) => {
  if (typeof target === 'object') {
    return target
  }
  if (typeof target === 'function') {
    return target(...funcArgs)
  }
}

/**
 * only inject type: [Object, Function]
 * @param {*} target [Object, Function]
 * @param {*} newTarget [Object, Function]
 */
export const injectValue = (target = {}, newTarget = {}) => {
  return () => ({
    ...promoteValue(target),
    ...promoteValue(newTarget)
  })
}

export const createWrap = targetFunc => {
  return (func, ...wrapArgs) => {
    return (...funcArgs) => {
      let trackArgs = wrapArgs.map(arg => {
        return promoteValue(arg, funcArgs)
      })
      targetFunc(...trackArgs).catch(e => {})
      return func(...funcArgs)
    }
  }
}

export const createWraper = targetFunc => {
  return (...wrapArgs) => {
    return (func) => {
      return (...funcArgs) => {
        let trackArgs = wrapArgs.map(arg => {
          return promoteValue(arg, funcArgs)
        })
        targetFunc(...trackArgs).catch(e => {})
        return func(...funcArgs)
      }
    }
  }
}

export default {
  create,
  createWrap,
  createWraper,
  promoteValue,
  injectValue,
  Tracker
}
